import java.io.IOException; 
import java.util.StringTokenizer; 

import org.apache.hadoop.io.IntWritable; 
import org.apache.hadoop.io.LongWritable; 
import org.apache.hadoop.io.DoubleWritable; 
import org.apache.hadoop.io.Text; 
import org.apache.hadoop.mapreduce.Mapper; 

public class BetaValueAdderMapper extends Mapper<LongWritable, Text, Text, DoubleWritable> 
{ 

        @Override 
        protected void map(LongWritable key,Text value, Context context) throws IOException,InterruptedException 
        { 
                String text=value.toString();
                 //Extract info
                String[] tokens = text.split("\\s");
                 //Filter out the head line.. 
                if(!tokens[0].subSequence(0, 2).equals("cg"))
                return;
                
                for(int i=0;i<tokens.length;i++)
                {
                         tokens[i]=tokens[i].trim();
                }
                if(tokens[1].equals("NA"))return; 
                if(tokens[2].equals(""))return; 
                double numDouble= Double.parseDouble(tokens[1]);
                context.write(new Text(tokens[2]), new DoubleWritable(numDouble)); 
        } 
}