

import java.io.IOException; 
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path; 
import org.apache.hadoop.io.IntWritable; 
import org.apache.hadoop.io.DoubleWritable;
import org.apache.hadoop.io.SequenceFile;
import org.apache.hadoop.io.Text; 


//import org.apache.hadoop.mapred.TextInputFormat;
//import org.apache.hadoop.mapred.KeyValueTextInputFormat;
import org.apache.hadoop.mapreduce.Job; 
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat; 
import org.apache.hadoop.mapreduce.lib.map.InverseMapper;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat; 
import org.apache.hadoop.mapreduce.lib.output.SequenceFileOutputFormat;
import org.apache.hadoop.mapreduce.lib.output.TextOutputFormat;
import org.apache.hadoop.mapreduce.lib.input.SequenceFileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.TextInputFormat;


public class BetaValueRanking
{ 
      public static void main(String[] args)throws IOException, InterruptedException, ClassNotFoundException 
      { 

                Job job=new Job(); 
                job.setJarByClass(BetaValueRanking.class); 
                Path tempath=new Path("/user/zhidong/temp");//Here is the location of temp file, must be changed when running in your folder
                Configuration conf=new Configuration();
                FileInputFormat.addInputPath(job,new Path(args[0])); 
                FileSystem.get(conf).delete(tempath,true);
                FileOutputFormat.setOutputPath(job,tempath); 

                job.setMapperClass(BetaValueAdderMapper.class); 
                job.setReducerClass(BetaValueAdderReducer.class); 

                job.setOutputKeyClass(Text.class); 
                job.setOutputValueClass(DoubleWritable.class); 

                job.setOutputFormatClass(SequenceFileOutputFormat.class);
                job.waitForCompletion(false);
                
                System.out.println("Start the second job");
                Job jobsort=new Job();

                FileInputFormat.addInputPath(jobsort, tempath);
                jobsort.setOutputKeyClass(DoubleWritable.class);
                jobsort.setOutputValueClass(Text.class);
                
                jobsort.setInputFormatClass(SequenceFileInputFormat.class);

                jobsort.setMapperClass(InverseMapper.class);
                jobsort.setNumReduceTasks(10);
                Path result=new Path(args[1]);
                FileSystem.get(conf).delete(result,true);
                FileOutputFormat.setOutputPath(jobsort, result);
                jobsort.setSortComparatorClass(DoubleWritable.Comparator.class);
                jobsort.waitForCompletion(false);


        } 
} 
