import java.io.IOException;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.conf.Configured;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.SequenceFile;
import org.apache.hadoop.io.SequenceFile.Reader;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.Reducer;
import org.apache.hadoop.util.Tool;
import org.apache.hadoop.util.ToolRunner;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.SequenceFileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
import org.apache.hadoop.mapreduce.lib.output.SequenceFileOutputFormat;
public class KMeansMain
{
public static void  main(String[] args) throws Exception
 {              

                String BASE_PATH = "/user/zhidong/TCGAkmeans";
                String CEN_PATH = "/user/zhidong/TCGAkmeans/center/centroid.txt";

                int iteration = 0;
                Configuration conf = new Configuration();
                conf.set("num.iteration", iteration + "");
                //conf.set("DATAPATH", DATA_PATH);

                Path in = new Path(args[0]);
                Path center = new Path(CEN_PATH);
                conf.set("CENPATH", center.toString());
                Path out = new Path(BASE_PATH + "/clustering/depth_0");

                Job job = new Job(conf);
                job.setJobName("KMeansPrepare Clustering");

                job.setMapperClass(KMeansMapper.class);
                job.setReducerClass(KMeansReducer.class);
                job.setJarByClass(KMeansMain.class);

                FileInputFormat.addInputPath(job, in);
                FileSystem fs = FileSystem.get(conf);
                if (fs.exists(out))
                        fs.delete(out, true);

                if (fs.exists(center))
                        fs.delete(out, true);

                if (fs.exists(in))
                        fs.delete(out, true);

                FileOutputFormat.setOutputPath(job, out);
               // job.setInputFormatClass(SequenceFileInputFormat.class);
                job.setOutputFormatClass(SequenceFileOutputFormat.class);

                job.setOutputKeyClass(IntWritable.class);
                job.setOutputValueClass(LongWritable.class);
                job.waitForCompletion(true);

                // fixed iteration upper bound
                int counter = 2;
                // number of iterations
                iteration++;
                while (counter > 0) 
                {
                        conf = new Configuration();
                        conf.set("CENPATH", BASE_PATH + "/clustering/depth_"
                                        + (iteration - 1) + "/" + "part-r-00000");
                        conf.set("num.iteration", iteration + "");
                        //String nextPath="CENPATH", BASE_PATH + "/clustering/depth_" + (iteration - 1) + "/" + "part-r-00000/"; 
                        //KMeansMapper.
                        //conf.set("DICTPATH", DATA_PATH);
                        job = new Job(conf);
                        job.setJobName("KMeans Clustering " + iteration);

                        job.setMapperClass(KMeansMapper.class);
                        job.setReducerClass(KMeansReducer.class);
                        job.setJarByClass(KMeansMain.class);

                        in = new Path(args[0]);
                        out = new Path(BASE_PATH + "/clustering/depth_" + iteration);

                        FileInputFormat.addInputPath(job, in);
                        if (fs.exists(out))
                                fs.delete(out, true);
 
                          

                        FileOutputFormat.setOutputPath(job, out);
                       // job.setInputFormatClass(SequenceFileInputFormat.class);
                        if(counter!=1)
                        {
                             job.setOutputFormatClass(SequenceFileOutputFormat.class);
                        }
                        job.setOutputKeyClass(IntWritable.class);
                        job.setOutputValueClass(LongWritable.class);

                        job.waitForCompletion(true);
                        counter--;
                        iteration++;
               }
                System.exit(job.waitForCompletion(true) ? 0 : 1);
     
      }
}
